// *******************************************************************
//
//  A Teaching Environement for Remote Lecturing in Higher Education
//
//         Prototype Implementation of a  Scalable Multicast Protocol
//
//                          Werner Geyer
//                      University of Mannheim
//                     Praktische Informatik IV
//                              L 15, 16
//	                    68131 Mannheim
//                             Germany
//
//              geyer@pi4.informatik.uni-mannheim.de
//
// *******************************************************************
//
//  Copyright (c) 1996, 1997
//
//     Lehrstuhl Praktische Informatik IV
//     University of Mannheim
//     Germany
//
//  All rights reserved.
//
//  Permission to use, copy, modify, and distribute this
//  software and its documentation for any purpose and without
//  fee is hereby granted, provided that the above copyright
//  notice appear in all copies and that both that copyright
//  notice and this permission notice appear in supporting
//  documentation.
//
//  We make no representations about the suitability of this
//  software for any purpose.  It is provided "as is" without
//  express or implied warranty.
//
//
//  Author: Werner Geyer
//          Praktische Informatik IV
//          University of Mannheim
//          email: geyer@pi4.informatik.uni-mannheim.de
//
// *******************************************************************
// program : BlockedADU.cpp
// authors : Martin Grumann
// date    : Aug 1996
// update  : Feb 1997
// desc    : Defines needed operators for usage of List.h
// *******************************************************************
#ifndef __BLOCKEDADU_CPP
#define __BLOCKEDADU_CPP

#include <stdio.h>
#include <iostream> // cout
#include "SMP.h"
#include "BlockedADU.h"


/*********************************************************************
 Name    : BlockedADU
 Param   :
 Result  :
 Desc    : Constructor
 Calledby:
 Uses    :
 *********************************************************************/
SMP::BlockedADU::BlockedADU(int s, int o, int l, int t)
  : Segment(s), Offset(o), Length(l), Type(t) {}


SMP::BlockedADU::BlockedADU(int t, void* d, int s, unsigned char ttl)
  : Type(t), data((char*)d), size(s), Ttl(ttl) {}


/*********************************************************************
 Name    : BlockedADU
 Param   :
 Result  :
 Desc    : Constructor
 Calledby:
 Uses    :
 *********************************************************************/
SMP::BlockedADU::BlockedADU(int s, int o, int l, int t, unsigned char ttl)
  : Segment(s), Offset(o), Length(l), Type(t), Ttl(ttl) {}

/*********************************************************************
 Name    : BlockedADU::operator<
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/
bool SMP::BlockedADU::operator<(const BlockedADU& b) {
  return true;
  // Damit wird eine neue blockierte ADU immer
  // an letzter Stelle eingefuegt
  // RateControlList ist somit ein FIFO-Puffern
}


/*********************************************************************
 Name    : BlockedADU::operator!=
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/
bool SMP::BlockedADU::operator!=(const BlockedADU& b) {
  if ((Segment != b.Segment) || (Offset != b.Offset))
      return true;
  return false;
}


/*********************************************************************
 Name    : BlockedADU::operator==
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/
bool SMP::BlockedADU::operator==(const BlockedADU& b) {
  if ((Segment == b.Segment) && (Offset == b.Offset))
      return true;
  return false;
}


/*********************************************************************
 Name    : BlockedADU:: Print()
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/
void SMP::BlockedADU:: Print() {
 fprintf(SMP::debug, "(%u,%u,%u)", Segment, Offset, Length);
}


#endif
