// *******************************************************************
//
//  A Teaching Environement for Remote Lecturing in Higher Education
//
//         Prototype Implementation of a  Scalable Multicast Protocol
//
//                          Werner Geyer
//                      University of Mannheim
//                     Praktische Informatik IV
//                              L 15, 16
//	                    68131 Mannheim
//                             Germany
//
//              geyer@pi4.informatik.uni-mannheim.de
//
// *******************************************************************
//
//  Copyright (c) 1996, 1997
//
//     Lehrstuhl Praktische Informatik IV
//     University of Mannheim
//     Germany
//
//  All rights reserved.
//
//  Permission to use, copy, modify, and distribute this
//  software and its documentation for any purpose and without
//  fee is hereby granted, provided that the above copyright
//  notice appear in all copies and that both that copyright
//  notice and this permission notice appear in supporting
//  documentation.
//
//  We make no representations about the suitability of this
//  software for any purpose.  It is provided "as is" without
//  express or implied warranty.
//
//
//  Author: Werner Geyer
//          Praktische Informatik IV
//          University of Mannheim
//          email: geyer@pi4.informatik.uni-mannheim.de
//
// *******************************************************************
// program : BlockedADU.h
// authors : Martin Grumann, Werner Geyer
// date    : Aug 1996
// update  : Feb 1997
// desc    : Defines needed operators for usage of List.h
// *******************************************************************

#ifndef __BLOCKEDADU_H
#define __BLOCKEDADU_H

namespace SMP {
class BlockedADU {
 public:
  
  //
  // types needed for rate control list in order
  // to identify the corresponding send function
  //
  // ADU     = Application Data Unit
	// URADU   = Unreliable ADU
  // RADU    = Repair ADU
  // DADU_RQ = Delayed ADU Request
  // DADU_RP = Delayed ADU Response
  //
  enum {ADU, URADU, RADU, DADU_RQ, DADU_RP}; 
    
  BlockedADU(int, void*, int, unsigned char = '0');
  BlockedADU(int, int, int, int);
  BlockedADU(int, int ,int, int, unsigned char);
  bool operator<(const BlockedADU&);
  bool operator!=(const BlockedADU&);
  bool operator==(const BlockedADU&);
  void Print();
    
  char * data;
  int size;

  int Segment;
  int Offset;
  int Length;
  int Type;
  unsigned char Ttl;  // only needed for repair adus
};
}

#endif
