// *******************************************************************
//
//  A Teaching Environement for Remote Lecturing in Higher Education
//
//         Prototype Implementation of a  Scalable Multicast Protocol
//
//                          Werner Geyer
//                      University of Mannheim
//                     Praktische Informatik IV
//                              L 15, 16
//	                    68131 Mannheim
//                             Germany
//
//              geyer@pi4.informatik.uni-mannheim.de
//
// *******************************************************************
//
//  Copyright (c) 1996, 1997
//
//     Lehrstuhl Praktische Informatik IV
//     University of Mannheim
//     Germany
//
//  All rigths reserved
//
//  Permission to use, copy, modify, and distribute this
//  software and its documentation for any purpose and without
//  fee is hereby granted, provided that the above copyright
//  notice appear in all copies and that both that copyright
//  notice and this permission notice appear in supporting
//  documentation.
//
//  We make no representations about the suitability of this
//  software for any purpose.  It is provided "as is" without
//  express or implied warranty.
//
//
//  Author: Werner Geyer
//          Praktische Informatik IV
//          University of Mannheim
//          email: geyer@pi4.informatik.uni-mannheim.de
//
// *******************************************************************
// program : Member.cpp
// authors : Martin Grumann
// date    : Aug 1996
// update  : Feb 1997
// desc    : Defines needed operators for usage of List.h
// *******************************************************************
#ifndef __MEMBER_CPP
#define __MEMBER_CPP

#include <iostream> // cout
#include <stdio.h>
#include "SMP.h"
#include "Member.h"



/*********************************************************************
 Name    : Member::Member
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/
SMP::Member::Member(unsigned int ssrc)
  : SSRC(ssrc), SN(0), HighestNum(0), timestampSent(0),
    timestampReceived(0), delay(0), IpAddr(0), Port(0), New(true) {}


/*********************************************************************
 Name    : Member::Member
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/
SMP::Member::Member(unsigned int ssrc, unsigned int ipaddr, int port)
  : SSRC(ssrc), SN(0), HighestNum(0), timestampSent(0),
    timestampReceived(0), delay(0), IpAddr(ipaddr), Port(port), New(true) {}

SMP::Member::~Member() {
}

/*********************************************************************
 Name    :
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/
bool SMP::Member::operator==(const Member& m) {
  if (SSRC == m.SSRC)
       return true;
  return false;
}


/*********************************************************************
 Name    : Member::operator!=
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/
bool SMP::Member::operator!=(const Member& m) {
  return (!operator==(m));
}


/*********************************************************************
 Name    : Member::operator<
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/
bool SMP::Member::operator<(const Member& m) {
  if (SSRC < m.SSRC)
       return true;
  return false;
}


/*********************************************************************
 Name    : Member::Print
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/
void SMP::Member::Print() {
  fprintf(SMP::debug, "(%u,%u)", SSRC, SN);
}

#endif


