// *******************************************************************
//
//  A Teaching Environement for Remote Lecturing in Higher Education
//
//         Prototype Implementation of a  Scalable Multicast Protocol
//
//                          Werner Geyer
//                      University of Mannheim
//                     Praktische Informatik IV
//                              L 15, 16
//	                    68131 Mannheim
//                             Germany
//
//              geyer@pi4.informatik.uni-mannheim.de
//
// *******************************************************************
//
//  Copyright (c) 1996, 1997
//
//     Lehrstuhl Praktische Informatik IV
//     University of Mannheim
//     Germany
//
//  All rigths reserved
//
//  Permission to use, copy, modify, and distribute this
//  software and its documentation for any purpose and without
//  fee is hereby granted, provided that the above copyright
//  notice appear in all copies and that both that copyright
//  notice and this permission notice appear in supporting
//  documentation.
//
//  We make no representations about the suitability of this
//  software for any purpose.  It is provided "as is" without
//  express or implied warranty.
//
//
//  Author: Werner Geyer
//          Praktische Informatik IV
//          University of Mannheim
//          email: geyer@pi4.informatik.uni-mannheim.de
//
// *******************************************************************
// program : Member.h
// authors : Martin Grumann
// date    : Aug 1996
// update  : Feb 1997
// desc    : Defines needed operators for usage of List.h
// *******************************************************************

#ifndef __MEMBER_H
#define __MEMBER_H

#ifdef WIN32
#pragma warning(disable: 4786)
#endif


//#include "List.h"
#include "Operation.h"
#include "ReceivedADU.h"
#include "receivedlist.h"
#include "operationslist.h"

namespace SMP {
class Member {
public:
  Member(unsigned int);
  Member(unsigned int, unsigned int, int);
  ~Member();
  bool operator==(const Member&);
  bool operator!=(const Member&);
  bool operator<(const Member&);
  unsigned int SSRC;
  unsigned int SN;
  unsigned int HighestNum;
  unsigned int timestampSent;
  unsigned int timestampReceived;
  unsigned int delay;
  unsigned int IpAddr;
  int Port;
  unsigned int LastSessionMessage;
  bool New;
  bool ActiveMember;
  //  SORTLIST<Operation> OperationsList;
  //  SORTLIST<ReceivedADU> ReceivedList;
  OperationsList operationslist;
  ReceivedList receivedlist;
  void Print();
};
}

#endif


