#ifndef __MEMBERSET_CPP
#define __MEMBERSET_CPP

#include "MemberSet.h"


SMP::MemberSet::~MemberSet() {
  //cout << "delete MemberSet" << endl;
  memberset.clear();
}


/*********************************************************************
 Name    : MemberSet::MemberSet
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/
SMP::MemberSet::MemberSet()
 : Count(0), Max_Count(MAX_MEMBERS_PER_SESSION_MESSAGE) {}


/*********************************************************************
 Name    : MemberSet::First
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/
SMP::Member* SMP::MemberSet::First() {
  if (!memberset.empty()) {
    pos = memberset.begin();
    return *pos;
  } else 
    return NULL;
}

/*********************************************************************
 Name    : MemberSet::Find
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/
bool SMP::MemberSet::Find(Member* m) {
  if (memberset.empty()) return false;

  std::set<Member*>::iterator walk = memberset.begin();

  while (walk != memberset.end()) {
    if (**walk == *m) return true;
    ++walk;
  }

  return false;
}


/*********************************************************************
 Name    : MemberSet::Next
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/
SMP::Member* SMP::MemberSet::Next() {
  ++pos;
  if (pos != memberset.end()) {
    return *pos;
  } else
    return NULL;
}


/*********************************************************************
 Name    : MemberSet::Insert
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/
void SMP::MemberSet::Insert(Member * p) {
	std::set<Member*>::iterator walk = memberset.begin();
  while (walk != memberset.end() && (**(walk) != *p)) ++walk;
  if (walk == memberset.end()) 
    memberset.insert(p);
  return;
}

#endif
