// *******************************************************************
//
//  A Teaching Environement for Remote Lecturing in Higher Education
//
//         Prototype Implementation of a  Scalable Multicast Protocol
//
//                          Werner Geyer
//                      University of Mannheim
//                     Praktische Informatik IV
//                              L 15, 16
//	                    68131 Mannheim
//                             Germany
//
//              geyer@pi4.informatik.uni-mannheim.de
//
// *******************************************************************
//
//  Copyright (c) 1996, 1997
//
//     Lehrstuhl Praktische Informatik IV
//     University of Mannheim
//     Germany
//
//  All rights reserved.
//
//  Permission to use, copy, modify, and distribute this
//  software and its documentation for any purpose and without
//  fee is hereby granted, provided that the above copyright
//  notice appear in all copies and that both that copyright
//  notice and this permission notice appear in supporting
//  documentation.
//
//  We make no representations about the suitability of this
//  software for any purpose.  It is provided "as is" without
//  express or implied warranty.
//
//
//  Author: Werner Geyer
//          Praktische Informatik IV
//          University of Mannheim
//          email: geyer@pi4.informatik.uni-mannheim.de
//
// *******************************************************************
// program : Operation.cpp
// authors : Martin Grumann
// date    : Aug 1996
// update  : Feb 1997
// desc    : Defines needed operators for usage of List.h
// *******************************************************************
#ifndef __OPERATION_CPP
#define __OPERATION_CPP


#include <iostream> // cout
#include <stdio.h>
#include "SMP.h"
#include "Operation.h"

unsigned int GetTimestamp();

/*********************************************************************
 Name    : Operation::Operation
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/
SMP::Operation::Operation(unsigned int SN)
  : OpId(SN) {}


/*********************************************************************
 Name    : Operation::Operation
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/
SMP::Operation::Operation(unsigned int SN, int seg, unsigned int offset, int len)
  : OpId(SN), Segment(seg), Offset(offset), Length(len) {}


SMP::Operation::Operation(unsigned int SN, void * d, int s)
  : OpId(SN), data((char*)d), size(s) {
  repair_time = 0;
  creation_time = GetTimestamp();
}


/*********************************************************************
 Name    : Operation::operator<
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/
bool SMP::Operation::operator<(const Operation& op) {
  if (OpId < op.OpId) // na ja, aber so ist's schneller
      return true;
  return false;
}


/*********************************************************************
 Name    : Operation::operator!=
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/
bool SMP::Operation::operator!=(const Operation& op) {
  if (OpId != op.OpId)
      return true;
  return false;
}


/*********************************************************************
 Name    : Operation::operator==
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/
bool SMP::Operation::operator==(const Operation& op) {
  if (OpId == op.OpId)
      return true;
  return false;
}


/*********************************************************************
 Name    : Operation:: Print
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/
void SMP::Operation:: Print() {
 fprintf(SMP::debug, "(%u,%u,%u,%u)", OpId, Segment, Offset, Length);
}


#endif
