// *******************************************************************
//
//  A Teaching Environement for Remote Lecturing in Higher Education
//
//         Prototype Implementation of a  Scalable Multicast Protocol
//
//                          Werner Geyer
//                      University of Mannheim
//                     Praktische Informatik IV
//                              L 15, 16
//	                    68131 Mannheim
//                             Germany
//
//              geyer@pi4.informatik.uni-mannheim.de
//
// *******************************************************************
//
//  Copyright (c) 1996, 1997
//
//     Lehrstuhl Praktische Informatik IV
//     University of Mannheim
//     Germany
//
//  All rights reserved.
//
//  Permission to use, copy, modify, and distribute this
//  software and its documentation for any purpose and without
//  fee is hereby granted, provided that the above copyright
//  notice appear in all copies and that both that copyright
//  notice and this permission notice appear in supporting
//  documentation.
//
//  We make no representations about the suitability of this
//  software for any purpose.  It is provided "as is" without
//  express or implied warranty.
//
//
//  Author: Werner Geyer
//          Praktische Informatik IV
//          University of Mannheim
//          email: geyer@pi4.informatik.uni-mannheim.de
//
// *******************************************************************
// program : Operation.h
// authors : Martin Grumann
// date    : Aug 1996
// update  : Feb 1997
// desc    :
// *******************************************************************

#ifndef __OPERATION_H
#define __OPERATION_H

#ifdef WIN32
#pragma warning(disable: 4786)
#endif


//#include "List.h"
#include <set>

// *******************************************************************
// maximum time for data to be kept if smp late join is disabled (ms)
// *******************************************************************
#define OP_DISCARD 120000  

namespace SMP {
class Operation {
public:
  Operation(unsigned int, void*, int);
  Operation(unsigned int);
  Operation(unsigned int, int, unsigned int, int);
  bool operator<(const Operation&);
  bool operator!=(const Operation&);
  bool operator==(const Operation&);
  void Print();
  unsigned int OpId;  // = sequence number 
  int Segment;
  unsigned int Offset;
  int Length;

  unsigned int creation_time;
  unsigned int repair_time;
  char* data;
  int size;
  unsigned int insert_time;
  //  SORTLIST<unsigned int> MemberList;
  std::set<unsigned int> MemberList;
};
}

#endif
