// *******************************************************************
//
//  A Teaching Environement for Remote Lecturing in Higher Education
//
//         Prototype Implementation of a  Scalable Multicast Protocol
//
//                          Werner Geyer
//                      University of Mannheim
//                     Praktische Informatik IV
//                              L 15, 16
//	                    68131 Mannheim
//                             Germany
//
//              geyer@pi4.informatik.uni-mannheim.de
//
// *******************************************************************
//
//  Copyright (c) 1996, 1997
//
//     Lehrstuhl Praktische Informatik IV
//     University of Mannheim
//     Germany
//
//  All rights reserved.
//
//  Permission to use, copy, modify, and distribute this
//  software and its documentation for any purpose and without
//  fee is hereby granted, provided that the above copyright
//  notice appear in all copies and that both that copyright
//  notice and this permission notice appear in supporting
//  documentation.
//
//  We make no representations about the suitability of this
//  software for any purpose.  It is provided "as is" without
//  express or implied warranty.
//
//
//  Author: Werner Geyer
//          Praktische Informatik IV
//          University of Mannheim
//          email: geyer@pi4.informatik.uni-mannheim.de
//
// *******************************************************************
// program : receivedADU.cpp
// authors : Martin Grumann
// date    : Aug 1996
// update  : Feb 1997
// desc    : defines needed operators for usage of List.h
// *******************************************************************
#ifndef __RECEIVEDADU_CPP
#define __RECEIVEDADU_CPP


#include <iostream> // cout
#include <stdio.h>
#include "SMP.h"
#include "ReceivedADU.h"



/*********************************************************************
 Name    : ReceivedADU::ReceivedADU
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/
SMP::ReceivedADU::ReceivedADU(int sn, int seg, int o, int l)
  : SN(sn), Segment(seg), Offset(o), Length(l) {}

SMP::ReceivedADU::ReceivedADU(unsigned int sn, void * d, int s)
  : SN(sn), data((char*)d), size(s) {}

/*********************************************************************
 Name    : ReceivedADU::operator<
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/
bool SMP::ReceivedADU::operator<(const ReceivedADU& r) {
  if(SN <= r.SN)
     return true;
  return false;
  // Die Liste ReceivedList ist nach den Sequenznummern
  // aufsteigend sortiert
}


/*********************************************************************
 Name    : ReceivedADU::operator!=
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/
bool SMP::ReceivedADU::operator!=(const ReceivedADU& b) {
  if (SN != b.SN)
      return true;
  return false;
}


/*********************************************************************
 Name    : ReceivedADU::operator==
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/
bool SMP::ReceivedADU::operator==(const ReceivedADU& b) {
  if (SN == b.SN)
      return true;
  return false;
}


/*********************************************************************
 Name    : ReceivedADU:: Print
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/
void SMP::ReceivedADU:: Print() {
  fprintf(SMP::debug, "(%u)", SN);
}


#endif
