// *******************************************************************
//
//  A Teaching Environement for Remote Lecturing in Higher Education
//
//         Prototype Implementation of a  Scalable Multicast Protocol
//
//                          Werner Geyer
//                      University of Mannheim
//                     Praktische Informatik IV
//                              L 15, 16
//	                    68131 Mannheim
//                             Germany
//
//              geyer@pi4.informatik.uni-mannheim.de
//
// *******************************************************************
//
//  Copyright (c) 1996, 1997
//
//     Lehrstuhl Praktische Informatik IV
//     University of Mannheim
//     Germany
//
//  All rights reserved.
//
//  Permission to use, copy, modify, and distribute this
//  software and its documentation for any purpose and without
//  fee is hereby granted, provided that the above copyright
//  notice appear in all copies and that both that copyright
//  notice and this permission notice appear in supporting
//  documentation.
//
//  We make no representations about the suitability of this
//  software for any purpose.  It is provided "as is" without
//  express or implied warranty.
//
//
//  Author: Werner Geyer
//          Praktische Informatik IV
//          University of Mannheim
//          email: geyer@pi4.informatik.uni-mannheim.de
//
// *******************************************************************
// program : Time.cpp
// authors : Martin Grumann
// date    : Aug 1996
// update  : Feb 1997
// desc    : contains functions needed for timer list
// *******************************************************************
#ifndef __TIMEFUNCTIONS_CPP
#define __TIMEFUNCTIONS_CPP

#include "TimeFunctions.h"


#ifndef WIN32
/*********************************************************************
 Name    : operator<<
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/

ostream& operator<<(ostream& os, const struct timeval& t) {
  os  << "seconds: " << t.tv_sec << ", microseconds : " << t.tv_usec;
  return os;
}
#endif

/*********************************************************************
 Name    : rtcp_intervall
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/
double rtcp_intervall(int members,
                      double rtcp_bw,
                      int packet_size,
                      double* avg_rtcp_size,
                      bool initial) {

  double const RTCP_MIN_TIME = 5.0;        // Seconds
  double const RTCP_SIZE_GAIN = (1.0/16.0);
  double ret;
  double rtcp_min_time = RTCP_MIN_TIME;

  if (initial) {
      rtcp_min_time /= 2;
      *avg_rtcp_size = 76;
     // 28 (UDP/IP) + 12(RTP Header) + 4 (Length) + 2 (#Members)*16(SM Element)
  }

  *avg_rtcp_size += (packet_size - *avg_rtcp_size)*RTCP_SIZE_GAIN;

  ret = (*avg_rtcp_size)*members / rtcp_bw;
  if (ret < rtcp_min_time)
     ret = rtcp_min_time;

  return ret * (drand48() + 0.5);
}

/*********************************************************************
 Name    : Min
 Param   :
 Result  :
 Desc    :
 Calledby:
 Uses    :
 *********************************************************************/
int Min(int i1, int i2) {
  return  (i1 < i2) ?  i1 :  i2;
}



#endif





