#include "Demon.h"
#include <tk.h>
#include <iostream.h> // cout

#ifdef WIN32

#include <windows.h>

int uname(struct utsname *ub)
{
    char *ptr;
    DWORD version;
    SYSTEM_INFO sysinfo;
    char hostname[4096];

    version = GetVersion();
    GetSystemInfo(&sysinfo);

    switch (sysinfo.wProcessorArchitecture) {
    case PROCESSOR_ARCHITECTURE_INTEL:
	(void) strcpy(ub->machine, "ix86");
	break;
    case PROCESSOR_ARCHITECTURE_MIPS:
	(void) strcpy(ub->machine, "mips");
	break;
    case PROCESSOR_ARCHITECTURE_ALPHA:
	(void) strcpy(ub->machine, "alpha");
	break;
    case PROCESSOR_ARCHITECTURE_PPC:
	(void) strcpy(ub->machine, "ppc");
	break;
    default:
	(void) strcpy(ub->machine, "unknown");
	break;
    }

    if (version < 0x80000000) {
	(void) strcpy(ub->version, "NT");
    } else if (LOBYTE(LOWORD(version)) < 4) {
	(void) strcpy(ub->version, "Win32s");
    } else {			/* Win95 */
	(void) strcpy(ub->version, "Win95");
    }
    (void) sprintf(ub->release, "%u.%u",
		   (DWORD) (LOBYTE(LOWORD(version))),
		   (DWORD) (HIBYTE(LOWORD(version))));
    (void) strcpy(ub->sysname, "Windows");
    if (gethostname(hostname, sizeof(hostname)) == 0) {
	if (ptr = strchr(hostname, '.'))
	    *ptr = '\0';
    } else {
	perror("uname: gethostname failed");
	strcpy(hostname, "FAILURE");
    }
    strncpy(ub->nodename, hostname, sizeof(ub->nodename));
    ub->nodename[_SYS_NMLN - 1] = '\0';
    return 0;
}


int strcasecmp(const char *s1, const char *s2)
{
    return stricmp(s1, s2);
}


int nice(int pri)
{
    return 0;
}

extern void TkWinXInit(HINSTANCE hInstance);

#endif

#define DEFAULT_PORT 5000
#define DEFAULT_LOOP 1

Tcl_Interp * interp = Tcl_CreateInterp();
int port = DEFAULT_PORT;
int loop = DEFAULT_LOOP;

Demon Deamon;

Tk_ArgvInfo argTable[] = {
  {"-help", TK_ARGV_HELP, (char*)NULL, (char*)NULL, 
   "usage: smp [-l {0,1}] [-p port#]\n"},
  {"-l", TK_ARGV_INT, (char*)NULL, (char*)&loop, 
   "enable/disable local multicast loop"},
  {"-p", TK_ARGV_INT, (char*)NULL, (char*)&port,
   "specifies local port number for client connection"},
  {(char *) NULL, TK_ARGV_END, (char *) NULL, (char *) NULL,
   (char *) NULL}
};

main(int argc, char* argv[]) {
  
  if (Tk_ParseArgv(interp, NULL, &argc, argv, argTable, 0) != TCL_OK) {
    fprintf(stderr, "%s\n", interp->result);
    exit(1);
  }
  //cout << "port=" << port << endl;
  //cout << "loop=" << loop << endl;


  #ifdef WIN32
  loop = 1;
  #endif

  Deamon.run(port, (bool)loop);
	return 1;
}


