#include "operationslist.h"

SMP::OperationsList::OperationsList() {
}

SMP::OperationsList::~OperationsList() {
  operationslist.clear();
}

bool SMP::OperationsList::Insert(Operation* radu) {
  operationslist.insert(std::map<const unsigned int,Operation*>::
  			value_type(radu->OpId, radu));  
  //operationslist.insert(std::make_pair(radu->OpId, radu));  

  return true;
}

SMP::Operation * SMP::OperationsList::First() {
  if (!operationslist.empty()) {
    pos = operationslist.begin();
    return (pos->second);
  } else {
    return NULL;
  }
}

SMP::Operation * SMP::OperationsList::Next() {
  ++pos;
  if (pos != operationslist.end()) {
    return (pos->second);
  } else
    return NULL;
}

SMP::Operation * SMP::OperationsList::RemoveFirst() {
  if (!operationslist.empty()) {
    std::map<const unsigned int, Operation*>::iterator todelete = operationslist.begin();
    Operation * result = todelete->second;
    operationslist.erase(todelete);
    return result;
  } else
    return NULL;
}

SMP::Operation * SMP::OperationsList::Find(Operation * op) {
  std::map<const unsigned int, Operation*>::iterator walk = operationslist.begin();
  while (walk != operationslist.end() && *(walk->second) != *op) ++walk;
  if (walk != operationslist.end()) 
    return walk->second;
  else
    return NULL;      
}

SMP::Operation * SMP::OperationsList::Delete(Operation * op) {
  std::map<const unsigned int, Operation*>::iterator walk = operationslist.begin();
  while (walk != operationslist.end() && *(walk->second) != *op) ++walk;
  if (walk != operationslist.end()) {
    Operation * result = walk->second;
    operationslist.erase(walk);
    return result;
  } else 
    return NULL;
}

void SMP::OperationsList::Print() {
  std::map<const unsigned int, Operation*>::iterator walk;
  for (walk = operationslist.begin(); walk != operationslist.end(); ++walk)
    walk->second->Print();
}
