#include "ratectrlqueue.h"

SMP::RateCtrlQueue::RateCtrlQueue() {
}

SMP::RateCtrlQueue::~RateCtrlQueue() {
  queue.clear();
}

SMP::BlockedADU * SMP::RateCtrlQueue::First() {
  if (!queue.empty()) {
    pos = queue.begin();
    return *pos;
  } else {
    return NULL;
  }
}

SMP::BlockedADU * SMP::RateCtrlQueue::Next() {
  ++pos;
  if (pos != queue.end()) {
    return *pos;
  } else
    return NULL;
}

void SMP::RateCtrlQueue::AddFirst(BlockedADU * badu) {
  queue.push_front(badu);
}

SMP::BlockedADU * SMP::RateCtrlQueue::RemoveFirst() {
  if (!queue.empty()) {
    BlockedADU * result = queue.front();
    queue.pop_front();
    return result;
  } else
    return NULL;
}

bool SMP::RateCtrlQueue::Insert(BlockedADU * badu) {
  queue.push_back(badu);
  return true;
}

void SMP::RateCtrlQueue::Print() {
  std::deque<BlockedADU*>::iterator walk;
  for (walk = queue.begin(); walk != queue.end(); ++walk)
    (*walk)->Print();
}

void SMP::RateCtrlQueue::Destroy() {
  std::deque<BlockedADU*>::iterator walk;
  for (walk = queue.begin(); walk != queue.end(); ++walk)
    delete (*walk);
  queue.clear();
}
