#include <iostream> // cout
#include <stdio.h>
#include "SMP.h"
#include "timerlist.h"


SMP::TimerList::TimerList() {
  count = 0;
}

SMP::TimerList::~TimerList() {
  timerlist.clear();
}

bool SMP::TimerList::Empty() {
  return timerlist.empty();
}

bool SMP::TimerList::Insert(Timer* ptimer) {
  if (timerlist.empty()) {
    count++;
    //cout << "TimerList::Insert - called " << count << endl;
    timerlist.push_front(ptimer);
    return true;
  }

  std::list<Timer*>::iterator i = timerlist.begin();
  while ((i != timerlist.end()) && ((*i)->EndZeitPunkt < ptimer->EndZeitPunkt)) {
    ++i;
  }

  timerlist.insert(i, ptimer);
  count++;
  //cout << "TimerList::Insert - called " << count << endl;
  return true;
}

SMP::Timer * SMP::TimerList::First() {
  if (!timerlist.empty()) {
    pos = timerlist.begin();
    return (*pos);
  } else {
    return NULL;
  }
}

SMP::Timer * SMP::TimerList::Next() {
  ++pos;
  if (pos != timerlist.end()) {
    return (*pos);
  } else
    return NULL;
}

SMP::Timer * SMP::TimerList::RemoveFirst() {
  if (!timerlist.empty()) {

    Timer* t = timerlist.front();
    timerlist.pop_front();
    count--;
    //cout << "TimerList::RemoveFirst - called and done " << count << endl;
    return t;
  } else {
    //cout << "TimerList::RemoveFirst - called and failed" << endl;
    return NULL;
  }
}

SMP::Timer * SMP::TimerList::Find(Timer * timer) {
  if (timerlist.empty()) return NULL;

  std::list<Timer*>::iterator walk = timerlist.begin();
  while ((walk != timerlist.end()) && (**walk != *timer)) ++walk;
  if (walk != timerlist.end()) 
    return *walk;
  else
    return NULL;      
}

SMP::Timer * SMP::TimerList::Delete(Timer * timer) {

  if (timerlist.empty()) return NULL;
  std::list<Timer*>::iterator walk = timerlist.begin();
  while ((walk != timerlist.end()) && ((**walk) != *timer)) ++walk;
  if (walk != timerlist.end()) {
    Timer * result = *walk;
    timerlist.erase(walk);

    count--;

    //cout << "TimerList::RemoveDelete - called and done " << count << endl;
    return result;
  } else {

    //cout << "TimerList::RemoveFirst - called and failed" << endl;
    return NULL;

  }
}

void SMP::TimerList::DeleteAll(Timer * timer) {
  if (timerlist.empty()) return;

  std::list<Timer*>::iterator walk = timerlist.begin();
  //std::list<Timer*>::iterator tmp;
  while (walk != timerlist.end()) {
    if ((*walk)->IsEqual(*timer)) {
      delete (*walk);
      //tmp = walk;
      walk = timerlist.erase(walk);
      //++walk;
      //cout << "TimerList::DeleteAll - one Timer deleted" << endl;
      count--;
    } else {
      ++walk;
    }
  }
}

void SMP::TimerList::Print() {
  if (timerlist.empty()) return;
  fprintf(SMP::debug, "Anzahl: %u", count);
  std::list<Timer*>::iterator walk;
  for (walk = timerlist.begin(); walk != timerlist.end(); ++walk)
    (*walk)->Print();
}
